﻿<?php

require_once( config_get( 'class_path' ) . 'MantisPlugin.class.php' );
$t_plugin_path = config_get( 'plugin_path' );
require_once( $t_plugin_path . 'Example' . DIRECTORY_SEPARATOR . 'util.php' );

class ExamplePlugin extends MantisPlugin {
    function register() {
    	# プラグインの名称
        $this->name = 'Example';
        # プラグインの詳細
        $this->description = 'バグの表示ページに機能追加';
        # プラグインの初期ページ
        $this->page = 'config';
		
		# プラグインのバージョン
        $this->version = '1.0';
        # 必要なMantisCoreのバージョン
        $this->requires = array('MantisCore' => '1.2.0',);
		
		# 作成者
        $this->author = 'symfo';
        # 作成者のアドレス
        $this->contact = 'symfo@example.com';
        # サポートページ
        $this->url = 'http://www.example.com';
    }
    
    # フックするイベントの指定
    function hooks() {
    	$hooks = array(
    		'EVENT_VIEW_BUG_DETAILS' => 'add_sample',
    		'EVENT_MENU_MAIN' => 'add_menu',
    	);
    	return $hooks;
    }
    
    #使用するテーブルの定義
    function schema() {
		$upgrade[] = Array('CreateTableSQL', Array(plugin_table( 'sample' ),
			"bug_id I UNSIGNED PRIMARY NOTNULL,
			package_name X NOTNULL DEFAULT '',
			class_name X NOTNULL DEFAULT '',
			method_name X NOTNULL DEFAULT '',
			last_modified I UNSIGNED NOTNULL DEFAULT 0,
			date_submitted I UNSIGNED NOTNULL DEFAULT 0",
			Array('mysql' => 'ENGINE=MyISAM DEFAULT CHARSET=utf8', 'pgsql' => 'WITHOUT OIDS')));
		return $upgrade;
    }
    
    # フックしたイベントで行う処理
    function add_sample($p_event, $bug_id) {
    	
    	#$bug_idからproject_idを取得し、タグ名称を生成
    	$tag_name = 'project_'.bug_get($bug_id)->project_id;
    	#未使用プロジェクトとして設定されている場合は、HTMLの生成を中断
    	if (plugin_config_get($tag_name, 1) == 0) {
    		return;
    	}
    	
    	$extra_data = get_extra_data($bug_id);
    	echo '<tr class="row-2"><td colspan="6" class="none">';
    	# === 開いているときの状態定義 ===
    	collapse_open( 'customize_package_form' );
    	echo '<form method="post" action="' . plugin_page('update') . '">';
    	#セキュリティトークンを付与
    	echo form_security_field('symfo-customize');
    	echo '<input type="hidden" name="bug_id" value="' . $bug_id . '">';
    	
    	echo '<table class="width100" cellspacing="1">';
    	echo '<tr>';
    	echo '<td class="form-title" colspan="2">';
    	
    	#アイコンの表示
    	collapse_icon( 'customize_package_form' );
    	echo '修正パッケージ';
    	echo '</td>';
    	echo '</tr>';
    	
		echo '<tr class="row-1">';
		echo '<td class="category">修正対象パッケージ</td>';
		echo '<td><input type="text" name="pkg" id="pkg" size="40" value="'.$extra_data['package_name'].'" /></td>';
		echo '</tr>';
    	
    	echo '<tr class="row-2">';
    	echo '<td class="category">修正対象クラス</td>';
    	echo '<td><input type="text" name="class" id="class" size="40" value="'.$extra_data['class_name'].'" /></td>';
    	echo '</tr>';
		
    	echo '<tr class="row-1">';
    	echo '<td class="category">修正対象メソッド</td>';
    	echo '<td><input type="text" name="method" id="method" size="40" value="'.$extra_data['method_name'].'" /></td>';
    	echo '</tr>';
    	
    	echo '<tr class="spacer"><td class="center" colspan="2">';
    	echo '<input type="submit" class="button" value="登録" />';
    	echo '</td></tr>';
    	
    	echo '</table>';
    	echo '</form>';
    	
    	# === 閉じているときの状態定義 ===
    	collapse_closed( 'customize_package_form' );
    	echo '<table class="width100" cellspacing="1">';
    	echo '<tr>';
    	echo '<td class="form-title">';
    	
    	#アイコンの表示
    	collapse_icon( 'customize_package_form' );
    	echo '修正パッケージ';
    	echo '</td>';
    	echo '</tr>';
    	echo '</table>';
    	
    	collapse_end( 'customize_package_form' );
    	
    	echo '</td></tr>';
    	
    }
    
    function add_menu() {
    	return Array('<a href="'.plugin_page('list').'"/>修正モジュール一覧</a>');
    }
}