﻿<?php

function get_extra_data($p_bug_id) {
	$extra_data = Array('package_name' => '', 'class_name' => '', 'method_name' => '');
	
	$c_bug_id = db_prepare_int( $p_bug_id );
	
	#テーブル名を取得
	$extra_data_table = plugin_table( 'sample' );
	
	$query = 'SELECT * FROM ' . $extra_data_table . ' WHERE bug_id = '. db_param();
	$result = db_query_bound( $query, Array( $c_bug_id ) );
	
	if (0 < db_num_rows( $result )) {
		$extra_data = db_fetch_array( $result );
	}
	
	return $extra_data;
}

function update_extra_data($p_bug_id, $p_pkg_text, $p_class_text, $p_method_text) {
	$c_bug_id = db_prepare_int( $p_bug_id );
	
	#テーブル名を取得
	$extra_data_table = plugin_table( 'sample' );
	
	$query = 'SELECT * FROM ' . $extra_data_table . ' WHERE bug_id = '. db_param();
	$result = db_query_bound( $query, Array( $c_bug_id ) );
	
	#データベースに登録する値
	$params = Array();
	#ログ出力用
	$history_logs = Array();
	
	#データなしのため、INSERT
	if (db_num_rows( $result) == 0) {
		$query = 'INSERT INTO ' . $extra_data_table;
		$query .= ' (bug_id, package_name, class_name, method_name, last_modified, date_submitted)';
		$query .= ' VALUES ';
		$query .= ' ('.db_param().','.db_param().','.db_param().','.db_param().','.db_param().','.db_param().')';
		
		$params[] = $c_bug_id;
		$params[] = $p_pkg_text;
		$params[] = $p_class_text;
		$params[] = $p_method_text;
		$params[] = db_now();
		$params[] = db_now();
		
		#空白以外だったら追加とみなす
		if (!is_null($p_pkg_text)) {
			$history_logs[] = Array('修正対象パッケージ追加', '' , $p_pkg_text);
		}
		if (!is_null($p_class_text)) {
			$history_logs[] = Array('修正対象クラス追加', '' , $p_class_text);
		}
		if (!is_null($p_method_text)) {
			$history_logs[] = Array('修正対象メソッド追加', '' , $p_method_text);
		}
		
	#データ存在のため、UPDATE
	} else {
		$old_data = db_fetch_array( $result );
		
		$query = 'UPDATE ' . $extra_data_table;
		$query .= ' SET ';
		$query .= ' package_name = ' . db_param() . ',';
		$query .= ' class_name = ' . db_param() . ',';
		$query .= ' method_name = ' . db_param() . ',';
		$query .= ' last_modified = ' . db_param();
		$query .= ' WHERE (bug_id = ' . db_param() . ')';
		
		$params[] = $p_pkg_text;
		$params[] = $p_class_text;
		$params[] = $p_method_text;
		$params[] = db_now();
		$params[] = $c_bug_id;
		
		#値が変更されていたらログ出力
		if ($p_pkg_text != $old_data['package_name']) {
			$history_logs[] = Array('修正対象パッケージ更新', $old_data['package_name'] , $p_pkg_text);
		}
		if ($p_class_text != $old_data['class_name']) {
			$history_logs[] = Array('修正対象クラス更新', $old_data['class_name'] , $p_class_text);
		}
		if ($p_method_text != $old_data['method_name']) {
			$history_logs[] = Array('修正対象メソッド更新', $old_data['method_name'] , $p_method_text);
		}
		
	}
	
	#登録実行
	db_query_bound( $query, $params );
	
	#ログに書き込み
	foreach ($history_logs as $history_log) {
		history_log_event_direct( $c_bug_id, $history_log[0], $history_log[1], $history_log[2]);
	}
}

function find_extra_data($p_is_csv = false) {
	$result = Array();
	#検索キーを探す。なければ初期値を設定してリターン
	#core/gpc_api.php
	if (!gpc_isset('target_project')) {
		$result['target_project'] = '0';
		$result['target_start'] = time();
		$result['target_end'] = time();
		return $result;
	}
	
	$result['target_project'] = gpc_get_string('target_project');
	if ($p_is_csv) {
		$result['target_start'] = gpc_get_int('target_start');
		$result['target_end'] = gpc_get_int('target_end');
	} else {
		$result['target_start'] = gpc_get_custom_field('target_start', CUSTOM_FIELD_TYPE_DATE);
		$result['target_end'] = gpc_get_custom_field('target_end', CUSTOM_FIELD_TYPE_DATE);
	}
	#検索実行
	$mantis_bug_table = db_get_table( 'mantis_bug_table' );
	$extra_data_table = plugin_table( 'sample' );
	$query_params = Array();
	
	$query = 'SELECT ';
	$query .= $mantis_bug_table.'.id,';
	$query .= $mantis_bug_table.'.summary,';
	$query .= $extra_data_table.'.package_name,';
	$query .= $extra_data_table.'.class_name,';
	$query .= $extra_data_table.'.method_name,';
	$query .= $extra_data_table.'.last_modified';
	
	$query .= ' FROM ';
	$query .= $mantis_bug_table.',';
	$query .= $extra_data_table;
	
	$query .= ' WHERE ';
	$query .= ' ('.$mantis_bug_table.'.id = '.$extra_data_table.'.bug_id)';
	
	$query .= ' AND(';
	$query .= $extra_data_table.'.last_modified BETWEEN ';
	$query .= db_param().' AND '.db_param();
	$query .= ' )';
	
	$query_params[] = $result['target_start'];
	$query_params[] = $result['target_end'] + (24 * 60 * 60);
	
	#0の場合は、「全プロジェクト」が選択されている
	if ($result['target_project'] != '0') {
		$query .= ' AND ('.$mantis_bug_table.'.project_id = '.db_param().')';
		#プロジェクトが階層構造になっている場合、カンマ区切りで
		#データがくるので、最後の番号を採用
		$query_params[] = array_pop(explode(';', $result['target_project']));
	}
	
	$result['items'] = db_query_bound( $query, $query_params );
	
	return $result;
}